"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const t = __importStar(require("@babel/types"));
const args = t.identifier('args');
const buildFn = (propName, node) => t.arrowFunctionExpression([args], t.blockStatement([
    t.expressionStatement(t.assignmentExpression('=', args, t.memberExpression(t.memberExpression(args, t.identifier('target')), t.identifier(propName)))),
    t.expressionStatement(t.assignmentExpression('=', node, t.conditionalExpression(t.binaryExpression('===', t.unaryExpression('typeof', node), t.stringLiteral('number')), t.unaryExpression('+', args), args)))
]));
exports.default = () => ({
    visitor: {
        JSXOpeningElement(p, { opts }) {
            const prefix = opts.prefix || 'r';
            const len = prefix.length;
            let propName = 'value';
            let attr;
            p.get('attributes').forEach(it => {
                if (!it.isJSXAttribute())
                    return;
                const nameNode = it.get('name');
                if (Array.isArray(nameNode) || !nameNode.isJSXIdentifier())
                    return;
                const v = it.get('value');
                if (Array.isArray(v))
                    return;
                const name = nameNode.node.name;
                if (name === 'type' && v.isStringLiteral()) {
                    const type = v.node.value;
                    if (type === 'checkbox' || type === 'radio')
                        propName = 'checked';
                }
                if (!name.startsWith(prefix))
                    return;
                switch (name.slice(len)) {
                    case 'Model':
                        attr = it;
                        break;
                    case 'PropName':
                        v.assertStringLiteral();
                        propName = v.node.value;
                        it.remove();
                        break;
                }
            });
            if (!attr)
                return;
            const value = attr.get('value');
            if (value.isJSXExpressionContainer() && propName) {
                const v = value.get('expression');
                if (!Array.isArray(v) && (v.isMemberExpression() || v.isIdentifier())) {
                    p.node.attributes.unshift(t.jsxAttribute(t.jsxIdentifier(propName), value.node), t.jsxAttribute(t.jsxIdentifier('onChange'), t.jsxExpressionContainer(buildFn(propName, v.node))));
                    attr.remove();
                    return;
                }
            }
            attr.remove();
            throw value.buildCodeFrameError('Unsupported expression.');
        },
        ObjectExpression(p, { opts }) {
            if (opts.notTransformObject)
                return;
            const prefix = opts.prefix || 'r';
            const len = prefix.length;
            let propName = 'value';
            let attr;
            p.get('properties').forEach(it => {
                if (!it.isObjectProperty())
                    return;
                const key = it.get('key');
                if (!key.isIdentifier())
                    return;
                const name = key.node.name;
                const v = it.get('value');
                if (name === 'type' && !Array.isArray(v) && v.isStringLiteral()) {
                    const type = v.node.value;
                    if (type === 'checkbox' || type === 'radio')
                        propName = 'checked';
                }
                switch (name.slice(len)) {
                    case 'Model':
                        attr = it;
                        break;
                    case 'PropName':
                        if (Array.isArray(v))
                            break;
                        v.assertStringLiteral();
                        propName = v.node.value;
                        it.remove();
                        break;
                }
            });
            if (!attr)
                return;
            const value = attr.get('value');
            if (propName && (value.isMemberExpression() || value.isIdentifier())) {
                p.node.properties.unshift(t.objectProperty(t.identifier(propName), value.node), t.objectProperty(t.identifier('onChange'), buildFn(propName, value.node)));
                attr.remove();
                return;
            }
            attr.remove();
            throw value.buildCodeFrameError('Unsupported expression.');
        }
    }
});
//# sourceMappingURL=babel.js.map