import React, { Component, PureComponent } from 'react';
declare module 'react' {
    interface Attributes {
        rModel?: string | boolean | number;
        rPropName?: string;
    }
}
export declare type GetStore = <M extends typeof Store>(store: M) => InstanceType<M>;
export declare class Store {
    toJSON: () => this;
    getStore: GetStore;
}
declare const REACT_COMPONENT: unique symbol;
export declare const NOT_PROXY: unique symbol;
export declare const getStore: <T extends typeof Store>(store: T) => any;
export declare const injectStore: <T extends typeof Store>(store: T) => (t: any, key: string) => any;
export declare const withStores: <T extends {
    [key: string]: typeof Store;
}>(stores: T, mapping?: (t: { [key in keyof T]: InstanceType<T[key]>; }, props: any) => any) => (C: typeof Component) => {
    new (props: {} | Readonly<{}>): {
        render(): React.FunctionComponentElement<{}>;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<{}>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<{}> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<{}>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<{}>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<{}>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): void;
    };
    new (props: {}, context: any): {
        render(): React.FunctionComponentElement<{}>;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<{}>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<{}> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<{}>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<{}>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<{}>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): void;
    };
    contextType?: React.Context<any>;
};
export declare const useStore: <T extends typeof Store>(store: T) => InstanceType<T>;
export declare const isReactInternal: (p: string) => boolean;
export declare const createProxy: <T>(s: T, onChange: (target: any) => void, id?: number, parent?: any, key?: any) => T;
export declare const newInstance: (...stores: Array<Store | typeof Store>) => React.FC & {
    getStore: GetStore;
    patch: () => void;
    addStores: (...stores: Array<Store | typeof Store>) => void;
};
export declare const createOutsideStore: <T>(store: T, onChange?: () => void) => T & {
    patch(): void;
};
export declare const useOutsideStore: <T>(fn: () => T) => T & {
    patch(): void;
};
export declare class ComponentWithStore extends Component {
    readonly [REACT_COMPONENT] = true;
    readonly patch: () => void;
    constructor(a: any);
}
export declare class PureComponentWithStore extends PureComponent {
    readonly [REACT_COMPONENT] = true;
    readonly patch: () => void;
    constructor(a: any);
}
export {};
