"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PureComponentWithStore = exports.ComponentWithStore = exports.useOutsideStore = exports.createOutsideStore = exports.newInstance = exports.createProxy = exports.isReactInternal = exports.useStore = exports.withStores = exports.injectStore = exports.getStore = exports.NOT_PROXY = exports.Store = void 0;
const react_1 = __importStar(require("react"));
class Store {
    toJSON;
    getStore = () => { throw new Error('Initialization is not complete yet.'); };
}
exports.Store = Store;
const STORE = Symbol('Store');
const PROXY = Symbol('Proxy');
const PARENT = Symbol('Parent');
const ROOT = Symbol('Root');
const KEY = Symbol('Key');
const BASE = Symbol('Base');
const ON_CHANGE = Symbol('onChange');
const REACT_COMPONENT = Symbol('reactComponent');
exports.NOT_PROXY = Symbol('notProxy');
const G = react_1.createContext(null);
let _getStore;
const TEXT = 'Initialization is not complete yet.';
const getStore = (store) => (_getStore && _getStore(store)) || new Proxy({}, {
    get(_, key) { if (key === STORE)
        return store;
    else
        throw new Error(TEXT); },
    set() { throw new Error(TEXT); }
});
exports.getStore = getStore;
const injectStore = (store) => (t, key) => (t[key] = exports.getStore(store));
exports.injectStore = injectStore;
const withStores = (stores, mapping) => (C) => {
    const F = props => {
        const ctx = react_1.useContext(G);
        const obj = {};
        for (const i in stores) {
            const id = ctx.ids.get(stores[i]);
            react_1.useContext(ctx.contexts[id]);
            obj[i] = ctx.stores[id];
        }
        return react_1.createElement(C, Object.assign(new Object(), props, (mapping && mapping(obj, props)) || obj));
    };
    return class extends react_1.PureComponent {
        render() {
            return react_1.createElement(F, this.props);
        }
    };
};
exports.withStores = withStores;
const useStore = (store) => {
    const m = react_1.useContext(G);
    const id = m.ids.get(store);
    const ctx = m.contexts[id];
    if (!ctx)
        throw new Error('No such store: ' + (store && (store.name || store)));
    react_1.useContext(ctx);
    return m.stores[id];
};
exports.useStore = useStore;
function V(v) { this.value = v; }
const isReactInternal = (p) => {
    switch (p) {
        case 'updater':
        case '_reactInternalFiber':
        case '_reactInternalInstance':
        case 'refs':
        case 'context':
        case 'props':
        case 'state': return true;
        default: return false;
    }
};
exports.isReactInternal = isReactInternal;
const handlers = {
    get(target, p, r) {
        if (target[REACT_COMPONENT] && exports.isReactInternal(p))
            return target[p];
        if (p === PROXY)
            return target[PROXY];
        if (typeof target[PROXY][p] !== 'undefined')
            return target[PROXY][p];
        const v = Reflect.get(target, p, r);
        if (p === 'toJSON')
            return v || (() => target);
        else if (v == null)
            return v;
        switch (typeof v) {
            case 'object': return v[exports.NOT_PROXY] || v[PROXY]
                ? v
                : (target[PROXY][p] = exports.createProxy(v, target[ON_CHANGE], target[ROOT], target, p));
            case 'function': return target[BASE] ? (target[PROXY][p] = v.bind(target[BASE])) : v;
            default: return v;
        }
    },
    set(target, p, v, r) {
        if (Object.is(Reflect.get(target, p, r), v))
            return true;
        const re = Reflect.set(target, p, v, r);
        if (re) {
            if (target[PROXY])
                target[PROXY][p] = undefined;
            target[ON_CHANGE](target);
        }
        return re;
    },
    deleteProperty(target, p) {
        const re = Reflect.deleteProperty(target, p);
        if (re)
            target[ON_CHANGE](target);
        if (typeof target[PROXY][p] !== 'undefined')
            delete target[PROXY][p];
        return re;
    }
};
const createProxy = (s, onChange, id, parent, key) => {
    s[PROXY] = new Object();
    s[PARENT] = parent;
    s[KEY] = key;
    s[ON_CHANGE] = onChange;
    if (id != null)
        s[ROOT] = id;
    const re = new Proxy(s, handlers);
    if (!key)
        s[BASE] = re;
    return re;
};
exports.createProxy = createProxy;
const newInstance = function () {
    let update = null;
    let flag = false;
    const ids = new WeakMap();
    const stores = [];
    const contexts = [];
    const value = new V({ ids, contexts, stores });
    const flags = [];
    let modified = false;
    let modifiedList = {};
    const updates = new Set();
    const patch = () => {
        if (!modified || updates.size === 0)
            return;
        updates.forEach(u => {
            const parent = u[PARENT];
            if (!parent)
                return;
            const k = u[KEY];
            const curV = parent[k];
            curV[PROXY] = parent[PROXY][k] = undefined;
            parent[k] = Array.isArray(curV) ? curV.slice() : Object.assign(new Object(), curV);
        });
        for (const id in modifiedList)
            flags[id] = !flags[id];
        modifiedList = {};
        updates.clear();
        modified = false;
        if (update)
            update(!flag);
    };
    const change = (target) => {
        updates.add(target);
        if (typeof modifiedList[target[ROOT]] === 'undefined')
            modifiedList[target[ROOT]] = null;
        if (!modified) {
            modified = true;
            new Promise(resolve => resolve()).then(patch);
        }
    };
    _getStore = (store) => stores[ids.get(store)];
    const gs = (store) => {
        const v = stores[ids.get(store)];
        if (!v)
            throw new Error('No such store: ' + (store && (store.name || store)));
        return v;
    };
    function addStore() {
        const len = arguments.length;
        for (let j = 0; j < len; j++) {
            const It = arguments[j];
            const store = It instanceof Store ? It : new It();
            const proto = Object.getPrototypeOf(store);
            const storeClass = proto.constructor;
            if (ids.has(storeClass)) {
                throw new Error('The store already exists: ' + (storeClass.name || storeClass));
            }
            Reflect.ownKeys(store).forEach(k => store[k] && store[k][STORE] && (store[k] = gs(store[k][STORE])));
            Reflect.ownKeys(proto).forEach(k => {
                if (proto[k]) {
                    if (proto[k][STORE])
                        store[k] = gs(proto[k][STORE]);
                    if (proto[k] instanceof Store)
                        store[k] = proto[k];
                }
            });
            store.getStore = gs;
            ids.set(storeClass, stores.push(exports.createProxy(store, change, stores.length)) - 1);
            contexts.push(react_1.createContext(null));
            flags.push(false);
        }
        if (update)
            update(!flag);
    }
    addStore.apply(null, arguments);
    const ret = (props) => {
        const v = react_1.useState(false);
        flag = v[0];
        update = v[1];
        return react_1.createElement(G.Provider, value, contexts.reduceRight((p, t, i) => react_1.createElement(t.Provider, new V(flags[i]), p), props.children));
    };
    ret.getStore = gs;
    ret.addStores = addStore;
    ret.patch = patch;
    _getStore = null;
    return ret;
};
exports.newInstance = newInstance;
let hasModified = false;
const updateList = new Set();
const createOutsideStore = (store, onChange) => {
    const patch = () => {
        updateList.forEach(u => {
            const parent = u[PARENT];
            if (!parent)
                return;
            const k = u[KEY];
            const curV = parent[k];
            curV[PROXY] = parent[PROXY][k] = undefined;
            parent[k] = Array.isArray(curV) ? curV.slice() : Object.assign(new Object(), curV);
        });
        updateList.clear();
        hasModified = false;
        if (onChange)
            onChange();
    };
    const proxy = exports.createProxy(store, target => {
        updateList.add(target);
        if (hasModified)
            return;
        hasModified = true;
        new Promise(resolve => resolve()).then(patch);
    });
    proxy.patch = patch;
    return proxy;
};
exports.createOutsideStore = createOutsideStore;
const useOutsideStore = (fn) => {
    const ret = react_1.useState(false);
    const ref2 = react_1.default.useRef();
    ref2.current = ret;
    const ref = react_1.default.useRef();
    if (!ref.current)
        ref.current = exports.createOutsideStore(fn(), () => ref2.current[1](!ref2.current[0]));
    return ref.current;
};
exports.useOutsideStore = useOutsideStore;
class ComponentWithStore extends react_1.Component {
    [REACT_COMPONENT] = true;
    patch;
    constructor(a) {
        super(a);
        return exports.createOutsideStore(this, () => this.forceUpdate());
    }
}
exports.ComponentWithStore = ComponentWithStore;
class PureComponentWithStore extends react_1.PureComponent {
    [REACT_COMPONENT] = true;
    patch;
    constructor(a) {
        super(a);
        return exports.createOutsideStore(this, () => this.forceUpdate());
    }
}
exports.PureComponentWithStore = PureComponentWithStore;
//# sourceMappingURL=index.js.map